import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { UserCommissionRole, UserCommissionRoleParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询用户绑定分红角色
 */
export async function pageUserCommissionRole(params: UserCommissionRoleParam) {
  const res = await request.get<ApiResult<PageResult<UserCommissionRole>>>(
    MODULES_API_URL + '/shop/user-commission-role/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询用户绑定分红角色列表
 */
export async function listUserCommissionRole(params?: UserCommissionRoleParam) {
  const res = await request.get<ApiResult<UserCommissionRole[]>>(
    MODULES_API_URL + '/shop/user-commission-role',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加用户绑定分红角色
 */
export async function addUserCommissionRole(data: UserCommissionRole) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/user-commission-role',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

export async function batchAddUserCommissionRole(data: UserCommissionRole[]) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/user-commission-role/batch',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改用户绑定分红角色
 */
export async function updateUserCommissionRole(data: UserCommissionRole) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/user-commission-role',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除用户绑定分红角色
 */
export async function removeUserCommissionRole(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/user-commission-role/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除用户绑定分红角色
 */
export async function removeBatchUserCommissionRole(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/user-commission-role/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询用户绑定分红角色
 */
export async function getUserCommissionRole(id: number) {
  const res = await request.get<ApiResult<UserCommissionRole>>(
    MODULES_API_URL + '/shop/user-commission-role/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
